=== debian/watch ===
# Watch control file for uscan
version=3
#opts=uversionmangle=s/(\d)[_.+-]?((RC|rc|pre|dev|beta|alpha)[\d.]*)$/$1~$2/ \ 
#https://github.com/PointCloudLibrary/pcl/releases .*/pcl-(\d\S*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

opts="uversionmangle=s/(\d)[_.+-]?((RC|rc|pre|dev|beta|alpha)[\d.]*)$/$1~$2/" \
https://github.com/PointCloudLibrary/pcl/releases .*/pcl-(\d\S*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
